// ColorText module
// Thanks to gNatFreak for the idea

// gNatFreak: Microgame where:
// A color comes up in the form of a word on the screen (i.e. RED), but the word RED is colored say GREEN. You must type the color the word is in, before time 
// runs out (and you wouldnt have much time).

// More examples:
// Word on screen: Green. (colored blue), type blue in chat within the time limit.
// Word: orange. (colored purple), type purple in chat within time limit.

// Time limits would have to be pretty quick. Its possible abbreviations could be used (i.e. make it so just the first letter of the color it is counts, but the 
// time you have to type that letter is around 2 seconds). So:
// Word: Grey (colored black), type b into chat. Care would have to be taken to prevent duplicate colors starting with the same letter.

static g_iColors[6] = {1, 2, 3, 4, 5, 6};
char g_sColors[6][12] = {"WHITE", "RED", "GREEN", "BLUE", "YELLOW", "PURPLE"};

int written_color;
int shown_color;
char questiontype[256];
int color_target; // either written or shown

Handle Colortext_sync = INVALID_HANDLE;

public int ColorText_OnMinigame() {
	AddToForward(g_justEntered, INVALID_HANDLE, ColorText_justEntered);
	AddToForward(g_OnEndMinigame, INVALID_HANDLE, ColorText_End);

	written_color = GetRandomInt(0,sizeof(g_sColors)-1);
	shown_color = GetRandomInt(0,sizeof(g_sColors)-1);
	
	if (GetRandomInt(0, 1) == 1) {
		color_target = written_color;
		SetMissionAll(0);
		char buffer[255];
		Format(questiontype, sizeof(questiontype), "INSTRUCTION_19_1");
		Format(buffer, sizeof(buffer), "%T", questiontype, LANG_SERVER);
	}
	else {
		char buffer[255];
		color_target = shown_color;
		SetMissionAll(1);
		Format(questiontype, sizeof(questiontype), "INSTRUCTION_19_2");
		Format(buffer, sizeof(buffer), "%T", questiontype, LANG_SERVER);
	}
	
	RegConsoleCmd("say", ColorText_Player_Say);
	RegConsoleCmd("say_team", ColorText_Player_Say);
	
	Colortext_sync = CreateHudSynchronizer();
}

public void ColorText_justEntered(int client) {
	if (IsValidClient(client)) {
		DisableClientWeapons(client);
		CreateTimer(1.0, PhraseShow, client);
	}
}
public Action PhraseShow(Handle timer, any client)
{
	if (IsValidClient(client)) {
		if(g_iColors[shown_color] == 1)PrintCenterText(client, "%t\n<font size='20'>%s</font>", questiontype, g_sColors[written_color]);
		if(g_iColors[shown_color] == 2)PrintCenterText(client, "%t\n<font color='#ff0000' size='20'>%s</font>", questiontype, g_sColors[written_color], client);
		if(g_iColors[shown_color] == 3)PrintCenterText(client, "%t\n<font color='#15fb00' size='20'>%s</font>", questiontype, g_sColors[written_color], client);
		if(g_iColors[shown_color] == 4)PrintCenterText(client, "%t\n<font color='#002bff' size='20'>%s</font>", questiontype, g_sColors[written_color], client);
		if(g_iColors[shown_color] == 5)PrintCenterText(client, "%t\n<font color='#fdff00' size='20'>%s</font>", questiontype, g_sColors[written_color], client);
		if(g_iColors[shown_color] == 6)PrintCenterText(client, "%t\n<font color='#bf1abf' size='20'>%s</font>", questiontype, g_sColors[written_color], client);
		//PrintToChat(client, "%i",g_iColors[shown_color]);
		//purple 800080
	}
}
public void ColorText_End() {
	CloseHandle(Colortext_sync);
}

public Action ColorText_Player_Say(int iClient, int iArgs) {
	if (!StrEqual(minigame, "ColorText")) return Plugin_Continue;
	if (!(IsValidClient(iClient))) return Plugin_Continue;
	if (!(IsClientParticipating(iClient))) return Plugin_Continue;
	if (iArgs < 1) return Plugin_Continue;
	
	if ((IsPlayerAlive(iClient)) && (status == 2) && (g_Complete[iClient] == false)) {
		// Retrieve the first argument and check it's the correct color
		char strArgument[64]; GetCmdArg(1, strArgument, sizeof(strArgument));
		
		if (!strncmp(g_sColors[color_target], strArgument, 2, false)) {
			SetStateClient(iClient, true, true);
			return Plugin_Handled;
		}
		else {
			ForcePlayerSuicide(iClient);
		}
	}
	return Plugin_Continue;
}