// Kamikaze module
#define WW_BOMB_MODEL "models/props/coop_cementplant/exloding_barrel/exploding_barrel.mdl"
#define WW_BOMB_SCOUT_MODEL "models/props/coop_cementplant/exloding_barrel/exploding_barrel.mdl"
#define PARTICLE_BOMB "explosion_child_smoke07c"
#define PARTICLE_EXPLODE "explosion_child_core06b"


public int Kamikaze_OnMinigame() {
	AddToForward(g_justEntered, INVALID_HANDLE, Kamikaze_justEntered);
	AddToForward(g_OnAlmostEnd, INVALID_HANDLE, Kamikaze_OnAlmostEnd);
	AddToForward(g_OnEndMinigame, INVALID_HANDLE, Kamikaze_End);
	AddToForward(g_OnTimerMinigame, INVALID_HANDLE, Kamikaze_TimerMinigame);
	AddToForward(g_PlayerDeath, INVALID_HANDLE, Kamikaze_PlayerDeath);

	int AllPlayers = GetClientCount(true);
	int target = GetRandomInt(1, AllPlayers);
	while ((!IsValidClient(target)) || GetClientTeam(target) < 2 || g_Spawned[target] == false || !IsPlayerAlive(target)) {
		target = GetRandomInt(1, AllPlayers);
	}

	g_Mission[target] = 1;
	g_result = 0;
	SetStateAll(true);
	SetStateClient(target, false);
}
public void Kamikaze_End() {
	for (int i = 1; i <= MaxClients; i++) {
		if (IsValidClient(i)) {
			SetEntityRenderColor(i, 255, 255, 255, 255);
		}
	}
}

public int Kamikaze_OnAlmostEnd() {
	for (int i = 1; i <= MaxClients; i++) {
		if (IsValidClient(i) && (g_Mission[i] == 1) && (g_result >= 2)) SetStateClient(i, true);
	}
}

public void Kamikaze_PlayerDeath(int client) {
	if (g_Mission[client] == 0) {
		SetStateClient(client, false);
		g_result += 1;
	}
	if (g_Mission[client] == 1) {
		SetEntityRenderColor(client, 255, 255, 255, 255);
		CreateTimer(0.0, Kamikaze_Ragdoll, client);
	}
}

public void Kamikaze_TimerMinigame(int timer) {
	for (int i = 1; i <= MaxClients; i++) {
		if (IsValidClient(i) && IsPlayerAlive(i) && (g_Mission[i] == 1)) {
			if (timer > 2) {
				ClientParticle(i, PARTICLE_BOMB, 2.0);
			}
			if (timer == 2) {
				ClientParticle(i, PARTICLE_EXPLODE, 4.0);
				float pos[3];
				GetClientAbsOrigin(i, pos);

				PyroExplode(pos);
				ExplosionDamage(pos);
			}
		}
	}
}
public Action Kamikaze_Ragdoll(Handle timer, any client) {
	if(IsValidClient(client)) {
		int rag = GetEntPropEnt(client, Prop_Send, "m_hRagdoll");
		if (rag > MaxClients && IsValidEntity(rag))
			AcceptEntityInput(rag, "Kill");
	}
	return Plugin_Handled;
}
public void Kamikaze_justEntered(int client) {
	if (IsValidClient(client)) {
		if (g_Mission[client] == 0) {
			DisableClientWeapons(client);
		}
		if (g_Mission[client] == 1) {
			DisableClientWeapons(client);
			SetEntityRenderColor(client, 255, 0, 0, 255);
		}
	}
}