// SimonSays module
//#define TF_CONDFLAG_CHARGING		  (1 << 17)


#define A_INSPECT 0
#define A_JUMP 1
#define A_CROUCH 2



// simon_action == 0 | Taunt
// simon_action == 1 | Jump
// simon_action == 2 | Crouch
// simon_action == 3 | Look Up
// simon_action == 4 | Look Down

// NEED TO ALLOW BUILDINGS

int simon_action;
int simon_or_someone;
bool g_Inspect[MAXPLAYERS + 1] = false;

public int SimonSays_OnMinigame() {
	AddToForward(g_OnGameFrame_Minigames, INVALID_HANDLE, SimonSays_OnGameFrame);
	AddToForward(g_justEntered, INVALID_HANDLE, SimonSays_justEntered);
	AddToForward(g_OnEndMinigame, INVALID_HANDLE, SimonSays_End);
	AddCommandListener(Command_Inspect, "+lookatweapon");
	AddCommandListener(Command_Inspect, "-lookatweapon");
	simon_action = GetRandomInt(0,2);
	simon_or_someone = GetRandomInt(0,1);
	for (int i = 1; i <= MaxClients; i++) {
		if (IsValidClient(i)) {
			g_Mission[i] = simon_action * 2 + simon_or_someone;
		}
	}
	
	// If simon says it (simon_or_someone == 0) set state to false until proven true
	// Otherwise, set to true until proven false
	SetStateAll(simon_or_someone == 1);
}

public int SimonSays_OnGameFrame() {	
	if (timeleft <= 6) {
		for (int i = 1; i <= MaxClients; i++) {
			// If the player is valid and taunting
			if(IsValidClient(i) && IsPlayerAlive(i) && IsClientParticipating(i)) {
				if (IsPlayerDoing(i)) {
					if (simon_or_someone == 0) {
					// If simon says it
						SetStateClient(i, true, true);
					}
					else if (g_Complete[i]) {
					// Otherwise, simon didn't say it and if we still haven't lost
						char message[256];
						char missionmessage[256];
						// Display "Simon didn't say it!"
						Format(missionmessage, sizeof(missionmessage), "INSTRUCTION_%d_20", GetMinigameConfNum("SimonSays", "id"), LANG_SERVER);
						Format(message, sizeof(message), "%t", missionmessage, LANG_SERVER);
						PrintCenterText(i,"<font color='#15fb00' size='20'>%s</font>", message);
						SetStateClient(i, false, true);
					}
				}
			}
		}
	}
}
public void SimonSays_justEntered(int client) {
	if (IsValidClient(client)){
		if(simon_action == 0){	
			g_Inspect[client] = false;			
		}
	} 
}
int IsPlayerDoing(int client) {
	switch (simon_action) {
		case A_INSPECT: {
			if (g_Inspect[client]) {
				return true;
			}
		}
		case A_JUMP: {
			if (GetClientButtons(client) & IN_JUMP) {
				return true;
			}
		}
		case A_CROUCH: {
			if (GetClientButtons(client) & IN_DUCK) {
				return true;
			}
		}	
	}
	return false;
}

public Action Command_Inspect(int client, const char[] sCommand, int iArgs)
{
	if(IsValidClient(client)){
		if(simon_action == A_INSPECT){
			g_Inspect[client] = true;
		}
	}
}

public void SimonSays_End() {
	RemoveCommandListener(Command_Inspect, "+lookatweapon");
	RemoveCommandListener(Command_Inspect, "-lookatweapon");
	g_attack = false;
}