int g_PlayerVisibleWeapon[MAXPLAYERS+1] = -1;
//#define COLLISION_GROUP_PUSHAWAY 17
stock bool IsValidClient(int iClient) {
	if (iClient <= 0) return false;
	if (iClient > MaxClients) return false;
	if (!IsClientConnected(iClient)) return false;
	return IsClientInGame(iClient);
}

int RegMinigame(char[] game_name, Function initFunc, Function onMinigameLoad = INVALID_FUNCTION)
{
	for (int i=0; i<sizeof(g_name); i++)
	{
		if (StrEqual(game_name, g_name[i]))
		{
			if (GetConVarBool(ww_log))
			{
				LogMessage("Registered minigame %s, id %d", game_name, i+1);
			}
			g_initFuncs[i] = initFunc;
			
			if (onMinigameLoad != INVALID_FUNCTION)
			{
				if (GetConVarBool(ww_log))
				{
					LogMessage("--Running onMinigameLoad function for %s", game_name);
				}
				Call_StartFunction(INVALID_HANDLE, onMinigameLoad);
				Call_Finish();
			}
			return;
		}
	}
	PrintToServer("Warning: Attempted to register minigame %s and failed--configuration not found", game_name);
}

int GiveId(bool mustbealive = false)
{
	int id = 0;
	for (int client = 1; client <= MaxClients; client++)
	{
		if (IsValidClient(client) && (mustbealive == false || IsPlayerAlive(client)))
		{
			id += 1;
			g_Id[client] = id;
		}
	}
}
int NoCollision(bool input)
{
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidEntity(i) && IsValidClient(i))
		{
			if (input)
			{
				SetEntData(i, g_offsCollisionGroup, 2, 4, true); // NO COLLISION
			}
			if (input == false)
			{
				SetEntData(i, g_offsCollisionGroup, 5, 4, true); // BRING BACK COLLISION
			}
		}
	}
}
int PyroExplode(float vec1[3])
{
	int color[4]={188,220,255,200};
	EmitSoundFromOrigin("ambient/explosions/explode_8.mp3", vec1);
	TE_SetupExplosion(vec1, g_ExplosionSprite, 10.0, 1, 0, 0, 750); // 600
	TE_SendToAll();
	TE_SetupBeamRingPoint(vec1, 10.0, 500.0, white, g_HaloSprite, 0, 10, 0.6, 10.0, 0.5, color, 10, 0);
	TE_SendToAll();
}

int ExplosionDamage(float origin[3])
{
	int maxplayers = GetMaxClients();
	
	float PlayerVec[3];
	float distance;
	for (int i = 1; i <= maxplayers; i++)
	{
		if( !IsClientInGame(i) || !IsPlayerAlive(i) )
		{
			continue;
		}
		GetClientAbsOrigin(i, PlayerVec);
		
		distance = GetVectorDistance(origin, PlayerVec, true);
		if(distance > 100000.0)
		{
			continue;
		}
		
		int dmg = RoundFloat(100000.0 - distance) / 50;
		int health = GetClientHealth(i) - dmg;
		
		if (health > 0)
		{
			SetEntityHealth(i,health);
		}
		if (health <= 0)
		{
			ForcePlayerSuicide(i);
		}
	}
}
int EmitSoundFromOrigin(const char[] sound,const float orig[3])
{
	EmitSoundToAll(sound,SOUND_FROM_WORLD,SNDCHAN_AUTO,SNDLEVEL_NORMAL,SND_NOFLAGS,SNDVOL_NORMAL,SNDPITCH_NORMAL,-1,orig,NULL_VECTOR,true,0.0);
}
stock int ClientParticle(int client, char effect[128], float time)
{
	float strflVec[3];
	GetClientEyePosition(client, strflVec);
	
	int strIParticle = CreateEntityByName("info_particle_system");
	char strName[128];
	if (IsValidEdict(strIParticle))
	{
		float strflPos[3];
		GetEntPropVector(client, Prop_Send, "m_vecOrigin", strflPos);
		TeleportEntity(strIParticle, strflPos, NULL_VECTOR, NULL_VECTOR);
		
		Format(strName, sizeof(strName), "target%i", client);
		DispatchKeyValue(client, "targetname", strName);
		
		DispatchKeyValue(strIParticle, "targetname", "tf2particle");
		DispatchKeyValue(strIParticle, "parentname", strName);
		DispatchKeyValue(strIParticle, "effect_name", effect);
		DispatchSpawn(strIParticle);
		SetVariantString(strName);
		AcceptEntityInput(strIParticle, "SetParent", strIParticle, strIParticle, 0);
		//SetVariantString("head");
		//AcceptEntityInput(strIParticle, "SetParentAttachment", strIParticle, strIParticle, 0);
		ActivateEntity(strIParticle);
		AcceptEntityInput(strIParticle, "start");
		
		CreateTimer(time, killprop_timer, strIParticle);
		//CreateTimer(0.1, updatePosition, _, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
	}
}

public Action killprop_timer(Handle hTimer, any prop)
{
	if (IsValidEntity(prop))
	{
		AcceptEntityInput(prop, "Kill" );
	}
	return Plugin_Stop;
}
stock int GetActivePlayers(int team = 0, bool mustbealive = false)
{
	int output = 0;
	for (int client = 1; client <= MaxClients; client++)
	{
		if (IsValidClient(client) && g_Spawned[client])
		{
			if (((team == 0 && GetClientTeam(client) >= 2) || (team > 0 && GetClientTeam(client) == team)) && (mustbealive == false || IsPlayerAlive(client)) && g_Participating[client] == true) output += 1;
		}
	}
	return output;
}
public int RemoveClientWeapons(int i) {
	if (GetConVarBool(ww_log)) LogMessage("Removing all client weapons");
	RemoveFakeWeapon(i);
	if (IsValidClient(i) && (IsPlayerAlive(i)) && (g_Winner[i] == 0)) {
		if ((weaponIndex0 = GetPlayerWeaponSlot(i, 0)) != -1)
			RemovePlayerItem(i, weaponIndex0);
		if ((weaponIndex1 = GetPlayerWeaponSlot(i, 1)) != -1)
			RemovePlayerItem(i, weaponIndex1);
		if ((weaponIndex3 = GetPlayerWeaponSlot(i, 3)) != -1)
			RemovePlayerItem(i, weaponIndex3);
		SetWeaponState(i, false);
	}
}

public Action SetWeaponState(int client, bool input) {
	char sWeapon[128];
	int ActiveWeapon = GetClientWeapon(client, sWeapon, sizeof(sWeapon));
	int iEntity = g_PlayerVisibleWeapon[client];
	if (IsValidEntity(ActiveWeapon)) {
		if (input == true) {
			
			SetEntityRenderColor(ActiveWeapon, 255, 255, 255, 255);
			SetEntityRenderMode(ActiveWeapon, RENDER_NORMAL);
			SetEntProp(client, Prop_Send, "m_bDrawViewmodel", 1);
			g_attack = true;
		}
		else {
			
			SetEntityRenderColor(ActiveWeapon, 255, 255, 255, 255);
			SetEntityRenderMode(ActiveWeapon, RENDER_NORMAL);
			//SetWeaponAmmo(client, 0, 0);
			SetEntProp(client, Prop_Send, "m_bDrawViewmodel", 1);
		}
	}
	if (iEntity > 0 && IsValidEntity(iEntity)) {
		if (input == true) {
			SetEntityRenderColor(iEntity, 255, 255, 255, 255);
			SetEntityRenderMode(iEntity, RENDER_NORMAL);
		}
		else {
			SetEntityRenderColor(iEntity, 255, 255, 255, 0);
			SetEntityRenderMode(iEntity, RENDER_TRANSCOLOR);
		}
	}
}

public Action GiveClientWeapon(int client, int slot, bool input) {
	if (IsValidClient(client) && IsPlayerAlive(client)) {	
		RemoveAllWeapons();			
		// Create a model everyone else can oodle at
		RemoveFakeWeapon(client);
		SetWeaponState(client, input);
	}
}

int RemoveFakeWeapon(int &iClient)
{
	if (GetConVarBool(ww_log))
	{
		LogMessage("Removing all client weapons");
	}
	int iEntity = g_PlayerVisibleWeapon[iClient];
	g_PlayerVisibleWeapon[iClient] = -1;
	
	if (iEntity > 0 && IsValidEdict(iEntity))
	{
		RemoveEdict(iEntity);
	}
}

public Action RemoveClientSlot(int i, int slot) {
	if (IsValidClient(i) && (IsPlayerAlive(i))) {
		RemovePlayerItem(i, slot);
	}
}

public Action RemoveAllWeapons() {
	if (GetConVarBool(ww_log)) LogMessage("Removing all weapons");
	for (int i = 1; i <= MaxClients; i++) {
		if (IsValidClient(i) && (IsPlayerAlive(i))) {
			RemoveClientWeapons(i);
		}
	}
}

int DisableClientWeapons(int client) {
	if (IsValidClient(client) && (IsPlayerAlive(client))) {
		RemoveClientWeapons(client);
		
		if (SpecialRound == 6)
		{
			SetClientSlot(client, 2);
		}
	
		else
		{
			SetClientSlot(client, 2);
			SetWeaponState(client, false);
			g_attack = false;
		}
	}
}

stock int RemoveItemEntity(int iClient, int iEntity) {
	if (IsValidClient(iClient) && IsItemEntity(iEntity)) {
		if (GetEntPropEnt(iEntity, Prop_Send, "m_hOwnerEntity") == iClient) {
			SDKCall(g_hSdkRemoveWearable, iClient, iEntity);			
		}
		RemoveEdict(iEntity);
	}
}

stock bool IsItemEntity(int iEntity) {
	if (iEntity > 0) {
		if (IsValidEdict(iEntity)) {
			decl String:strClassname[32];
			GetEdictClassname(iEntity, strClassname, sizeof(strClassname));
			if (StrEqual(strClassname, "tf_wearable", false)) return true;
			if (StrEqual(strClassname, "tf_wearable_demoshield", false)) return true;
			if (StrEqual(strClassname, "tf_usableitem", false)) return true;
			if (StrEqual(strClassname, "tf_powerup_bottle", false)) return true;			
		}
	}
	return false;
}

stock int ChangeClientTeamAlive(int client, int team)
{
	SetEntProp(client, Prop_Send, "m_lifeState", 2);
	ChangeClientTeam(client, team);
	SetEntProp(client, Prop_Send, "m_lifeState", 0);
	CS_RespawnPlayer(client);
}

int GetClientMaxHealth(int iClient)
{
	return GetEntProp(GetPlayerResourceEntity(), Prop_Send, "m_iMaxHealth", _, iClient); 
}

stock int FindEntityByClassname2(int startEnt, const char[] classname)
{
	/* If startEnt isn't valid shifting it back to the nearest valid one */
	while (startEnt > -1 && !IsValidEntity(startEnt))
	{
		startEnt--;
	}
	return FindEntityByClassname(startEnt, classname);
}

stock int CreateAllSprites()
{
	for (int client = 1; client <= MaxClients; client++)
	{
		if (IsValidClient(client))
		{
			CreateSprite(client);
		}
	}
}


stock int CreateSprite(int client)
{
	if (IsValidClient(client))
	{
		DestroySprite(client);
		if (IsPlayerAlive(client) && g_Points[client] > 0)
		{
			
			// Sprite name
			int points = g_Points[client];
			if (points > 19)
			{
				points = 19;
			}
			if (g_Winner[client] > 0)
			{
				points = 99;
			}
			char sprite[256];
			Format(sprite, sizeof(sprite), "materials/ww_overlays/csgoware_points%d.vmt", points);
			
			// Client ent
			char szTemp[64]; 
			Format(szTemp, sizeof(szTemp), "client%i", client);
			DispatchKeyValue(client, "targetname", szTemp);
			float vOrigin[3];
			GetClientAbsOrigin(client, vOrigin);
				
			vOrigin[2] += 50;
			
			int ent = CreateEntityByName("env_sprite_oriented");
			if (IsValidEntity(ent))
			{			 
				DispatchKeyValue(ent, "classname", "env_sprite_oriented");
				DispatchKeyValue(ent, "spawnflags", "1");
				DispatchKeyValue(ent, "framerate", "1");
				DispatchKeyValue(ent, "scale", "0.2");
				DispatchKeyValue(ent, "rendermode", "1");
				DispatchKeyValue(ent, "rendercolor", "255 255 255");
				DispatchKeyValue(ent, "model", sprite);
				DispatchKeyValue(ent, "parentname", szTemp);
				SetVariantString("ATTACH_NORMAL");
				SetVariantString("!activator");
				//AcceptEntityInput(ent, "SetParentAttachmentMaintainOffset", client, ent, 0); 
				DispatchSpawn(ent);
				TeleportEntity(ent, vOrigin, NULL_VECTOR, NULL_VECTOR);
				
				
				g_Sprites[client] = ent;
			}
		}
	}
}

stock int SetSpriteParent(int ent, char[] szTargetName)
{
	//SetVariantString(szTargetName);
	//AcceptEntityInput(ent, "SetParent", szTargetName, ent, 0);
	//SetVariantString("flag");
	SetVariantString("!activator");
	AcceptEntityInput(ent, "SetParentAttachmentMaintainOffset", !activator, ent, 1);
	//AcceptEntityInput(ent, "SetParent", -1, -1, 0);
	SetEntityMoveType(ent, MOVETYPE_WALK);
}

stock int DestroyAllSprites()
{
	for (int client = 1; client <= MaxClients; client++)
	{
		if (IsValidClient(client))
		{
			DestroySprite(client);
		}
	}
}

stock int DestroySprite(int client)
{
	if (IsValidClient(client))
	{
		int ent = g_Sprites[client];
		if ((g_Sprites[client] > 0) && IsValidEntity(ent))
		{			
			AcceptEntityInput(ent, "kill");
			g_Sprites[client] = 0;
		}
	}
}
public Action updatePosition(Handle timer)
{
	int ent; float vOrigin[3]; float vVelocity[3];
	for(int i = 1; i <= MaxClients; i++)
	{
		if (!IsClientInGame(i))
		{
			continue;
		}
		if ((ent = g_Sprites[i]) > 0)
		{
			if (!IsValidEntity(ent))
			{
				g_Sprites[i] = 0;
			}
			else
			{
				if ((ent = EntRefToEntIndex(ent)) > 0)
				{
					GetClientEyePosition(i, vOrigin);
					vOrigin[2] += 25.0;
					GetEntDataVector(i, gVelocityOffset, vVelocity);
					TeleportEntity(ent, vOrigin, NULL_VECTOR, vVelocity);
				}
			}
		}
	}
	return Plugin_Continue;
}
/* static const char MsgBlock[][]={"#Player_Cash_Award", "#Hint_try_not_to_injure_teammates", "#Team_Cash_Award", "#Player_Point_Award", "#Cstrike_TitlesTXT_Game_teammate_attack"
, "#Chat_SavePlayer_", "#SFUI_Notice_Match_Will_Start_Chat", "#SFUI_Notice_Warmup_Has_Ended", "#CSGO_Coach_Join_", "#CSGO_No_Longer_Coach"
,"#Player_You_Are_Now_Dominating", "#Player_You_Are_Still_Dominating", "#Player_On_Killing_Spree", "#hostagerescuetime", "#csgo_instr_explain_buymenu"}; */
//static const char MsgBlock[][]={"#Player_Cash_Award", "#Hint_try_not_to_injure_teammates", "#Team_Cash_Award", "#Player_Point_Award", "#Cstrike_TitlesTXT_Game_teammate_attack", "#Chat_SavePlayer_"};	 
public Action TextMsg(UserMsg msg_id, Handle pb, const int[] players, int playersNum, bool reliable, bool init)
{
	if(!reliable)
	{
		return Plugin_Continue;
	}

	char buffer[256];
	PbReadString(pb, "params", buffer, sizeof(buffer), 0);
	if(StrContains(buffer, "#Cstrike_TitlesTXT_Game_teammate_attack") == 0 || StrContains(buffer, "#Player_Cash_Award") == 0 || StrContains(buffer, "Console") == 0 || StrContains(buffer, "#Chat_SavePlayer") == 0)
	{
		return Plugin_Handled;
	}
	if (StrContains(buffer, "[SM] ") == 0)return Plugin_Handled;
/*	if (StrEqual(buffer, "#CCSUsrMsg_TextMsg", false)!= -1){
		return Plugin_Continue;
	} */
	return Plugin_Continue;
} 
int GetRandomPlayer()
{
	int clients[MAXPLAYERS+1]; int clientCount;
	for (int i = 1; i <= MaxClients; i++)
		if (IsClientInGame(i))
		clients[clientCount++] = i;
	return (clientCount == 0) ? -1 : clients[GetRandomInt(0, clientCount-1)];
}
int GetRandomPlayerTeam(int team)
{
	int clients[MAXPLAYERS+1]; int clientCount;
	for (int i = 1; i <= MaxClients; i++)
		if (IsClientInGame(i) && GetClientTeam(i) == team)
		clients[clientCount++] = i;
	return (clientCount == 0) ? -1 : clients[GetRandomInt(0, clientCount-1)];
}
bool ReadServercfg(const char[] fileName, const char[] cvar, char[] buffer, int buffersize)
{
    Handle file = OpenFile(fileName, "rt");
    if (file == INVALID_HANDLE)
        return false;

    bool result = false;

    char pattern[256];
    Format(pattern, sizeof(pattern), "^\\s*%s\\s+(\"[^\"]*\"|\\S+)\\s*(?://.*)?$", cvar);
    Handle reCvar = CompileRegex(pattern);

    //Search each line of the cfg file for the cvar
    char line[256];
    while (!IsEndOfFile(file) && ReadFileLine(file, line, sizeof(line)))
    {
        if (MatchRegex(reCvar, line) != -1)
        {
            //Store the value.
            GetRegexSubString(reCvar, 1, buffer, buffersize);
            result = true;
        }
    }
    
    if (result)
    {
        StripQuotes(buffer);
    }
    
    CloseHandle(file);
    CloseHandle(reCvar);
    return result;
}
public int Remove_Ragdoll(int client) {
	if(IsValidClient(client)) {
		int rag = GetEntPropEnt(client, Prop_Send, "m_hRagdoll");
		if (rag > MaxClients && IsValidEntity(rag))
			AcceptEntityInput(rag, "Kill");
	}
}
int ClientExplode(int client, float vec1[3])
{
	int color[4]={188,220,255,200};
	PrecacheSoundAny("weapons/hegrenade/explode4.wav",true);
	if(IsValidClient(client)){
		EmitSoundToAllAny("weapons/hegrenade/explode4.wav", SOUND_FROM_PLAYER, SNDCHAN_STATIC);
	}
	TE_SetupExplosion(vec1, g_ExplosionSprite, 10.0, 1, 0, 0, 750);
	TE_SendToAll();
	TE_SetupBeamRingPoint(vec1, 10.0, 500.0, white, g_HaloSprite, 0, 10, 0.6, 10.0, 0.5, color, 10, 0);
	TE_SendToAll();
}
int CreateParticle(int entity, char []particle)
{
	
	int ent = CreateEntityByName("info_particle_system");
	
	float particleOrigin[3];
	
	GetEntPropVector(entity, Prop_Data, "m_vecAbsOrigin", particleOrigin);

	DispatchKeyValue(ent , "start_active", "0");
	DispatchKeyValue(ent, "effect_name", particle);
	DispatchSpawn(ent);
	
	TeleportEntity(ent , particleOrigin, NULL_VECTOR,NULL_VECTOR);
	
	
	SetVariantString("!activator");
	AcceptEntityInput(ent, "SetParent", entity, ent, 0);
	
	ActivateEntity(ent);
	AcceptEntityInput(ent, "Start");
	
	entity = EntIndexToEntRef(ent);
}
int GetPlayerCountTeam(int team)
{
    int players_team;
    for (int i = 1; i <= MaxClients; i++)
    {
        if (IsValidClient(i) && IsPlayerAlive(i) && GetClientTeam(i) == team && IsClientParticipating(i))
            players_team++;
    }
    return players_team;
}